import { AfterContentInit, ChangeDetectorRef, ElementRef, QueryList, TemplateRef } from '@angular/core';
import { MenuItem, PrimeTemplate } from 'primeng/api';
import * as i0 from "@angular/core";
import * as i1 from "@angular/common";
import * as i2 from "@angular/router";
import * as i3 from "primeng/ripple";
import * as i4 from "primeng/tooltip";
import * as i5 from "primeng/api";
export declare class Dock implements AfterContentInit {
    private el;
    cd: ChangeDetectorRef;
    /**
     * Current id state as a string.
     * @group Props
     */
    id: string | undefined;
    /**
     * Inline style of the element.
     * @group Props
     */
    style: {
        [klass: string]: any;
    } | null | undefined;
    /**
     * Class of the element.
     * @group Props
     */
    styleClass: string | undefined;
    /**
     * MenuModel instance to define the action items.
     * @group Props
     */
    model: MenuItem[] | undefined | null;
    /**
     * Position of element. Valid values are 'bottom', 'top', 'left' and 'right'.
     * @group Props
     */
    position: 'bottom' | 'top' | 'left' | 'right';
    templates: QueryList<PrimeTemplate> | undefined;
    itemTemplate: TemplateRef<any> | undefined;
    currentIndex: number;
    constructor(el: ElementRef, cd: ChangeDetectorRef);
    ngAfterContentInit(): void;
    onListMouseLeave(): void;
    onItemMouseEnter(index: number): void;
    onItemClick(e: Event, item: MenuItem): void;
    get containerClass(): {
        [x: string]: boolean;
    };
    isClickableRouterLink(item: any): boolean;
    itemClass(index: number): {
        'p-dock-item': boolean;
        'p-dock-item-second-prev': boolean;
        'p-dock-item-prev': boolean;
        'p-dock-item-current': boolean;
        'p-dock-item-next': boolean;
        'p-dock-item-second-next': boolean;
    };
    static ɵfac: i0.ɵɵFactoryDeclaration<Dock, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<Dock, "p-dock", never, { "id": { "alias": "id"; "required": false; }; "style": { "alias": "style"; "required": false; }; "styleClass": { "alias": "styleClass"; "required": false; }; "model": { "alias": "model"; "required": false; }; "position": { "alias": "position"; "required": false; }; }, {}, ["templates"], never, false, never>;
}
export declare class DockModule {
    static ɵfac: i0.ɵɵFactoryDeclaration<DockModule, never>;
    static ɵmod: i0.ɵɵNgModuleDeclaration<DockModule, [typeof Dock], [typeof i1.CommonModule, typeof i2.RouterModule, typeof i3.RippleModule, typeof i4.TooltipModule], [typeof Dock, typeof i5.SharedModule, typeof i4.TooltipModule, typeof i2.RouterModule]>;
    static ɵinj: i0.ɵɵInjectorDeclaration<DockModule>;
}
