import { AfterContentInit, ChangeDetectorRef, QueryList, TemplateRef } from '@angular/core';
import { MenuItem, PrimeTemplate } from 'primeng/api';
import * as i0 from "@angular/core";
import * as i1 from "@angular/common";
import * as i2 from "@angular/router";
import * as i3 from "primeng/tooltip";
import * as i4 from "primeng/api";
import * as i5 from "primeng/icons/angledown";
import * as i6 from "primeng/icons/angleright";
import * as i7 from "primeng/icons/chevrondown";
import * as i8 from "primeng/icons/chevronright";
export declare class BasePanelMenuItem {
    private ref;
    constructor(ref: ChangeDetectorRef);
    handleClick(event: Event, item: MenuItem): void;
}
export declare class PanelMenuSub extends BasePanelMenuItem {
    panelMenu: PanelMenu;
    item: MenuItem | undefined;
    expanded: boolean | undefined;
    parentExpanded: boolean | undefined;
    transitionOptions: string | undefined;
    root: boolean | undefined;
    constructor(ref: ChangeDetectorRef, panelMenu: PanelMenu);
    onItemKeyDown(event: KeyboardEvent): void;
    getAnimation(): {
        value: string;
        params: {
            transitionParams: string;
            height: string;
        };
    };
    static ɵfac: i0.ɵɵFactoryDeclaration<PanelMenuSub, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<PanelMenuSub, "p-panelMenuSub", never, { "item": { "alias": "item"; "required": false; }; "expanded": { "alias": "expanded"; "required": false; }; "parentExpanded": { "alias": "parentExpanded"; "required": false; }; "transitionOptions": { "alias": "transitionOptions"; "required": false; }; "root": { "alias": "root"; "required": false; }; }, {}, never, never, false, never>;
}
export declare class PanelMenu extends BasePanelMenuItem implements AfterContentInit {
    /**
     * An array of menuitems.
     */
    model: MenuItem[] | undefined;
    /**
     * Inline style of the component.
     */
    style: {
        [klass: string]: any;
    } | null | undefined;
    /**
     * Style class of the component.
     */
    styleClass: string | undefined;
    /**
     * Whether multiple tabs can be activated at the same time or not.
     */
    multiple: boolean;
    /**
     * Transition options of the animation.
     */
    transitionOptions: string;
    templates: QueryList<PrimeTemplate> | undefined;
    submenuIconTemplate: TemplateRef<any> | undefined;
    animating: boolean | undefined;
    constructor(ref: ChangeDetectorRef);
    ngAfterContentInit(): void;
    collapseAll(): void;
    handleClick(event: MouseEvent, item: MenuItem): void;
    onToggleDone(): void;
    onItemKeyDown(event: KeyboardEvent): void;
    visible(item: MenuItem): boolean;
    getAnimation(item: MenuItem): {
        value: string;
        params: {
            transitionParams: string;
            height: string;
        };
    };
    static ɵfac: i0.ɵɵFactoryDeclaration<PanelMenu, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<PanelMenu, "p-panelMenu", never, { "model": { "alias": "model"; "required": false; }; "style": { "alias": "style"; "required": false; }; "styleClass": { "alias": "styleClass"; "required": false; }; "multiple": { "alias": "multiple"; "required": false; }; "transitionOptions": { "alias": "transitionOptions"; "required": false; }; }, {}, ["templates"], never, false, never>;
}
export declare class PanelMenuModule {
    static ɵfac: i0.ɵɵFactoryDeclaration<PanelMenuModule, never>;
    static ɵmod: i0.ɵɵNgModuleDeclaration<PanelMenuModule, [typeof PanelMenu, typeof PanelMenuSub], [typeof i1.CommonModule, typeof i2.RouterModule, typeof i3.TooltipModule, typeof i4.SharedModule, typeof i5.AngleDownIcon, typeof i6.AngleRightIcon, typeof i7.ChevronDownIcon, typeof i8.ChevronRightIcon], [typeof PanelMenu, typeof i2.RouterModule, typeof i3.TooltipModule, typeof i4.SharedModule]>;
    static ɵinj: i0.ɵɵInjectorDeclaration<PanelMenuModule>;
}
